/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { AfterViewInit, ElementRef, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { NzRowDirective } from './row.directive';
export interface EmbeddedProperty {
    span?: number;
    pull?: number;
    push?: number;
    offset?: number;
    order?: number;
}
export declare class NzColDirective implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private elementRef;
    nzRowDirective: NzRowDirective;
    renderer: Renderer2;
    private classMap;
    private destroy$;
    hostFlexStyle: string | null;
    nzFlex: string | number | null;
    nzSpan: number | null;
    nzOrder: number | null;
    nzOffset: number | null;
    nzPush: number | null;
    nzPull: number | null;
    nzXs: number | EmbeddedProperty | null;
    nzSm: number | EmbeddedProperty | null;
    nzMd: number | EmbeddedProperty | null;
    nzLg: number | EmbeddedProperty | null;
    nzXl: number | EmbeddedProperty | null;
    nzXXl: number | EmbeddedProperty | null;
    setHostClassMap(): void;
    setHostFlexStyle(): void;
    parseFlex(flex: number | string | null): string | null;
    generateClass(): object;
    constructor(elementRef: ElementRef, nzRowDirective: NzRowDirective, renderer: Renderer2);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
