/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { EventEmitter, OnDestroy } from '@angular/core';
import { NzI18nService } from 'ng-zorro-antd/i18n';
import { NzModalRef } from './modal-ref';
import { ModalButtonOptions, ModalOptions } from './modal-types';
export declare class NzModalFooterComponent implements OnDestroy {
    private i18n;
    config: ModalOptions;
    buttonsFooter: boolean;
    buttons: ModalButtonOptions[];
    locale: {
        okText?: string;
        cancelText?: string;
    };
    readonly cancelTriggered: EventEmitter<void>;
    readonly okTriggered: EventEmitter<void>;
    modalRef: NzModalRef;
    private destroy$;
    constructor(i18n: NzI18nService, config: ModalOptions);
    onCancel(): void;
    onOk(): void;
    /**
     * Returns the value of the specified key.
     * If it is a function, run and return the return value of the function.
     * @deprecated Not support use function type.
     * @breaking-change 10.0.0
     */
    getButtonCallableProp(options: ModalButtonOptions, prop: keyof ModalButtonOptions): boolean;
    /**
     * Run function based on the type and set its `loading` prop if needed.
     * @deprecated Should be set options' value by the user, not library.
     * @breaking-change 10.0.0
     */
    onButtonClick(options: ModalButtonOptions): void;
    ngOnDestroy(): void;
}
