/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { OnChanges, SimpleChanges } from '@angular/core';
import { AvatarShape, AvatarSize, ButtonShape, ButtonSize, InputSize } from './skeleton.type';
export declare class NzSkeletonElementDirective {
    nzActive: boolean;
    nzType: 'button' | 'input' | 'avatar';
}
export declare class NzSkeletonElementButtonComponent {
    nzShape: ButtonShape;
    nzSize: ButtonSize;
}
export declare class NzSkeletonElementAvatarComponent implements OnChanges {
    static ngAcceptInputType_nzShape: AvatarShape | undefined | null;
    static ngAcceptInputType_AvatarSize: AvatarSize | undefined | null;
    nzShape: AvatarShape;
    nzSize: AvatarSize;
    styleMap: {};
    ngOnChanges(changes: SimpleChanges): void;
}
export declare class NzSkeletonElementInputComponent {
    nzSize: InputSize;
}
