/**
 * @license
 * Copyright Alibaba.com All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ChangeDetectorRef, ElementRef, OnChanges, Renderer2 } from '@angular/core';
import { Subject } from 'rxjs';
export declare class NzCellFixedDirective implements OnChanges {
    private cdr;
    private renderer;
    private elementRef;
    nzRight: string | boolean;
    nzLeft: string | boolean;
    colspan: number | null;
    changes$: Subject<void>;
    isFirstRight: boolean;
    isLastLeft: boolean;
    isAutoLeft: boolean;
    isAutoRight: boolean;
    isFixedLeft: boolean;
    isFixedRight: boolean;
    isFixed: boolean;
    setIsFirstRight(isRightFirst: boolean): void;
    setIsLastLeft(isLeftLast: boolean): void;
    setAutoLeftWidth(autoLeft: string | null): void;
    setAutoRightWidth(autoRight: string | null): void;
    constructor(cdr: ChangeDetectorRef, renderer: Renderer2, elementRef: ElementRef);
    ngOnChanges(): void;
}
